# Enum Class SmiAccess

java.lang.Object
java.lang.Enum<SmiAccess>
com.snmp4j.smi.SmiAccess

All Implemented Interfaces:
  `Serializable, Comparable<SmiAccess>, Constable`

public enum SmiAccess extends Enum<SmiAccess>
The SmiMaxAccess enumerates the ACCESS values of SMIv2 for MODULE-COMPLIANCE and AGENT-CAPABILITIES statements, including the deprecated `writeOnly` for backward-compatibility.

Since:
  1.7.0 (Pro edition only)
Author:
  Frank Fock

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from class Enum

  `Enum.EnumDesc<E>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `accessibleForNotify`
  Object accesible for notifications only.
  `notAccessible`
  Not acessible object.
  `notImplemented`
  Not implemented object.
  `readCreate`
  Object is read-write accessible and creatable via SNMP.
  `readOnly`
  Object is read-only.
  `readWrite`
  Object is read-write accessible - creation is not supported via SNMP SET.
  `writeOnly`
  Object is write-only (deprecated in SMIv2)

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static SmiAccess`
  `fromSmiValue(String smiValue)`
  Gets the `MaxAccess` from a MAX-ACCESS (or ACCESS in SMIv1) clause string.
  `String`
  `getSmiValue()`
  Gets the MAX-ACCESS (or ACCESS in SMIv1) clause string.
  `boolean`
  `isAccessible()`
  Checks if this `SmiObject` is accessible or not.
  `boolean`
  `isCreatable()`
  Checks if this `SmiObject` is read-create or not.
  `boolean`
  `isImplemented()`
  Checks if this `SmiObject` is implemented or not.
  `boolean`
  `isReadOnly()`
  Checks if this `SmiObject` is read-only or not.
  `boolean`
  `isWritable()`
  Checks if this `SmiObject` is read-write or not.
  `static SmiAccess`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static SmiAccess[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### notImplemented

    public static final SmiAccess notImplemented
    Not implemented object.

  - ### notAccessible

    public static final SmiAccess notAccessible
    Not acessible object.

  - ### accessibleForNotify

    public static final SmiAccess accessibleForNotify
    Object accesible for notifications only.

  - ### writeOnly

    public static final SmiAccess writeOnly
    Object is write-only (deprecated in SMIv2)

  - ### readOnly

    public static final SmiAccess readOnly
    Object is read-only.

  - ### readWrite

    public static final SmiAccess readWrite
    Object is read-write accessible - creation is not supported via SNMP SET.

  - ### readCreate

    public static final SmiAccess readCreate
    Object is read-write accessible and creatable via SNMP.

- ## Method Details

  - ### values

    public static SmiAccess[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static SmiAccess valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### getSmiValue

    public String getSmiValue()
    Gets the MAX-ACCESS (or ACCESS in SMIv1) clause string.
    Returns:
      the SMI access string.

  - ### fromSmiValue

    public static SmiAccess fromSmiValue(String smiValue)
    Gets the `MaxAccess` from a MAX-ACCESS (or ACCESS in SMIv1) clause string.
    Parameters:
      `smiValue` - the SMI access string.
    Returns:
      `null` if `smiValue` is not a valid ACCESS/MAX-ACCESS clause value or the matching enumeration value.

  - ### isAccessible

    public boolean isAccessible()
    Checks if this `SmiObject` is accessible or not.
    Returns:
      `true` if access is not `notAccessible` and not `notImplemented`.

  - ### isImplemented

    public boolean isImplemented()
    Checks if this `SmiObject` is implemented or not.
    Returns:
      `true` if access is not `notImplemented`.

  - ### isReadOnly

    public boolean isReadOnly()
    Checks if this `SmiObject` is read-only or not.
    Returns:
      `true` if access is `readOnly`.

  - ### isWritable

    public boolean isWritable()
    Checks if this `SmiObject` is read-write or not.
    Returns:
      `true` if access is `readWrite` or greater.

  - ### isCreatable

    public boolean isCreatable()
    Checks if this `SmiObject` is read-create or not.
    Returns:
      `true` if access is `readCreate`.